unit UdpTcpIpc_TestApp_Main_Kylix;

interface

uses
  SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls, QForms,
  QDialogs, QStdCtrls, QExtCtrls, QComCtrls,
  HxTcpIpcUdp;
type
  TfrmMain = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Panel1: TPanel;
    Panel3: TPanel;
    Panel2: TPanel;
    mmo: TMemo;
    btnUdp: TButton;
    btnTcpServer: TButton;
    btnTcpClient: TButton;
    btnIpcServer: TButton;
    btnIpcClient: TButton;
    btnIpcSend: TButton;
    btnTcpSend: TButton;
    btnUdpSend: TButton;
    btnUdpReply: TButton;
    speUdpListeningPort: TSpinEdit;
    speUdpDestPort: TSpinEdit;
    edtUdpText: TEdit;
    edtTcpText: TEdit;
    edtIpcText: TEdit;
    speTcpListeningPort: TSpinEdit;
    speTcpDestPort: TSpinEdit;
    speIpcListeningPort: TSpinEdit;
    speIpcDestPort: TSpinEdit;
    speTcpClient: TSpinEdit;
    speIpcClient: TSpinEdit;
    procedure btnUdpClick(Sender: TObject);
    procedure btnTcpServerClick(Sender: TObject);
    procedure btnTcpClientClick(Sender: TObject);
    procedure btnTcpSendClick(Sender: TObject);
    procedure btnUdpSendClick(Sender: TObject);
    procedure btnUdpReplyClick(Sender: TObject);
    procedure btnIpcSendClick(Sender: TObject);
    procedure btnIpcClientClick(Sender: TObject);
    procedure btnIpcServerClick(Sender: TObject);
    procedure speIpcListeningPortChanged(Sender: TObject;
      NewValue: Integer);
    procedure speIpcDestPortChanged(Sender: TObject; NewValue: Integer);
    procedure speTcpDestPortChanged(Sender: TObject; NewValue: Integer);
    procedure speTcpListeningPortChanged(Sender: TObject;
      NewValue: Integer);
    procedure speUdpListeningPortChanged(Sender: TObject;
      NewValue: Integer);
    procedure speUdpDestPortChanged(Sender: TObject; NewValue: Integer);
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    svrIpc: THxIpcServer;
    clntIpc: THxIpcClient;
    svrTCP: THxTcpServer;
    clntTCP: THxTcpClient;
    udp: THxUdp;
    procedure HandlesvrIpcDataAvailable(ptr: pointer; iSize, iDescr: integer);
    procedure HandlesvrIpcClientAborted(iDescr: integer);
    procedure HandlesvrIpcNewClient(iDescr: integer);
    procedure HandleNotify(S: string);
    procedure HandleClientConnectionClosed;
    procedure HandleClientDataAvailable(ptr: pointer; iSize: integer);
    procedure HandleUdpData(ptr: pchar; iSize: integer; sRemoteIP,
      sPort: string);
    procedure SetPorts;
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.xfm}

procedure TfrmMain.HandlesvrIpcDataAvailable( ptr: pointer; iSize, iDescr: integer );
var
  s: string;
begin
  s := StrPas( pchar( ptr ));
  mmo.Lines.Add(Format('Data from client: %d, message: %s, size: %d',
                      [iDescr,s, iSize]));
end;

procedure TfrmMain.HandlesvrIpcClientAborted( iDescr: integer );
begin
  mmo.Lines.Add(Format('Client: %d aborted',[iDescr]));
end;

procedure TfrmMain.HandlesvrIpcNewClient( iDescr: integer );
var
  sPort: string;
begin
  if Assigned( svrIpc )then
    sPort := svrIpc.ClientPort[ iDescr ]
  else if Assigned( svrTcp )then
    sPort := svrTcp.ClientPort[ iDescr ]
  else
    sPort := '??????';
  mmo.Lines.Add(Format('New Client: %d, Client-Port: %s',[iDescr, sPort]));

end;

procedure TfrmMain.HandleNotify( S: string );
begin
  mmo.Lines.Add(Format('Notify message: %s', [s]));
end;

procedure TfrmMain.btnIpcServerClick(Sender: TObject);
begin
  if Assigned( svrIpc )then
    exit;
  svrIpc := THxIpcServer.Create;
  svrIpc.Port := speIpcListeningPort.Text;
  svrIpc.OnDataAvailable := HandlesvrIpcDataAvailable;
  svrIpc.OnClientAborted := HandlesvrIpcClientAborted;
  svrIpc.OnNewClient := HandlesvrIpcNewClient;
  svrIpc.OnNotify := HandleNotify;
  svrIpc.Listen;

  btnIpcSend.Enabled := True;
//  btnIpcClient.Enabled := False;
end;

procedure TfrmMain.HandleClientDataAvailable( ptr: pointer; iSize: integer );
var
  s: string;
begin
  s := StrPas( pchar( ptr ));
  mmo.Lines.Add(Format('Data from server, message: %s, size: %d', [s, iSize]));
end;

procedure TfrmMain.HandleClientConnectionClosed;
begin
  mmo.Lines.Add('Sever logged off');
end;

procedure TfrmMain.btnIpcClientClick(Sender: TObject);
begin
  if Assigned( clntIpc )then
  begin
    if not( clntIpc.Connected )then
    begin
      clntIpc.Port := speIpcDestPort.Text;
      if clntIpc.Connect then
      begin
        mmo.Lines.Add('connected');
        btnIpcSend.Enabled := True;
      end
      else
        mmo.Lines.Add('Not connected');
    end;
    exit;
  end;

  clntIpc := THxIpcClient.Create;
  clntIpc.ServerAddress := 'localhost';
  clntIpc.Port := speIpcDestPort.Text;
  clntIpc.OnNotify := HandleNotify;
  clntIpc.OnDataAvailable := HandleClientDataAvailable;
  clntIpc.OnConnectionClosed := HandleClientConnectionClosed;
  if clntIpc.Connect then
  begin
    mmo.Lines.Add('connected');
    btnIpcSend.Enabled := True;
  end
  else
    mmo.Lines.Add('Not connected');
    
  speIpcClient.Enabled := False;
  btnIpcServer.Enabled := False;
end;

procedure TfrmMain.btnIpcSendClick(Sender: TObject);
begin
  if Assigned(clntIpc)then
    clntIpc.SendString( edtIpcText.Text )
  else if Assigned( svrIpc )then
    svrIpc.SendString( edtIpcText.Text, speIpcClient.Value );
end;

procedure TfrmMain.btnTcpServerClick(Sender: TObject);
begin
  if Assigned( svrTCP )then
    exit;

  svrTCP := THxTcpServer.Create;
  svrTCP.Port := speTcpListeningPort.Text;
  svrTCP.OnDataAvailable := HandlesvrIpcDataAvailable;
  svrTCP.OnClientAborted := HandlesvrIpcClientAborted;
  svrTCP.OnNewClient := HandlesvrIpcNewClient;
  svrTCP.OnNotify := HandleNotify;
  svrTCP.Listen;

//  btnTcpClient.Enabled := False;
  speTcpDestPort.Enabled := False;
  btnTcpSend.Enabled := True;
end;

procedure TfrmMain.btnTcpClientClick(Sender: TObject);
begin
  if Assigned( clntTcp )then
  begin
    if not( clntTcp.Connected )then
    begin
      clntTcp.Port := speTcpDestPort.Text;
      clntTcp.ServerAddress := 'localhost';
      if clntTcp.Connect then
      begin
        mmo.Lines.Add('TCP connected');
        btnTcpSend.Enabled := True;
      end
      else
        mmo.Lines.Add('TCP Not connected');
    end;
    exit;
  end;

  clntTcp := THxTcpClient.Create;
  clntTcp.ServerAddress := 'localhost';
  clntTcp.Port := speTcpDestPort.Text;
  clntTcp.OnNotify := HandleNotify;
  clntTcp.OnDataAvailable := HandleClientDataAvailable;
  clntTcp.OnConnectionClosed := HandleClientConnectionClosed;
  if clntTcp.Connect then
  begin
    mmo.Lines.Add('Tcp connected');
    btnTcpSend.Enabled := True;
  end
  else
    mmo.Lines.Add('Tcp Not connected');

  btnTcpServer.Enabled := False;
  speTcpListeningPort.Enabled := False;
  speTcpClient.Enabled := False;
end;

procedure TfrmMain.btnTcpSendClick(Sender: TObject);
begin
  if Assigned( clntTcp )then
    clntTcp.SendString( edtTcpText.Text )
  else if Assigned( svrTcp )then
    svrTcp.SendString( edtTcpText.Text, speTcpClient.Value );
end;

procedure TfrmMain.HandleUdpData( ptr: pchar; iSize: integer;
                                sRemoteIP, sPort: string );
var
  s: string;
begin
  s := StrPas( pchar( ptr ));
  mmo.Lines.Add(Format('Data by UDP, message: %s, size: %d, '+
                       'remoteIp: %s, Port: %s', [s, iSize, sRemoteIP, sPort]));
end;

procedure TfrmMain.btnUdpClick(Sender: TObject);
begin
  if Assigned( udp )then
    exit;

//  MemChk;

  udp := THxUdp.Create;
  udp.OnNotify := HandleNotify;
  udp.OnDataAvailable := HandleUdpData;
  udp.DestinationAddress := 'localhost';
  udp.DestinationPort := speUdpDestPort.Text;
  udp.ListeningPort := speUdpListeningPort.Text;

  btnUdpSend.Enabled := True;
  btnUdpReply.Enabled := True;
end;

procedure TfrmMain.btnUdpSendClick(Sender: TObject);
begin
  if not( Assigned( udp ))then
    exit;

  udp.SendString( edtUdpText.Text );
end;

procedure TfrmMain.btnUdpReplyClick(Sender: TObject);
begin
  if not( Assigned( udp ))then
    exit;

  udp.ReplyStr( edtUdpText.Text );
end;

procedure TfrmMain.speUdpDestPortChanged(Sender: TObject; NewValue: Integer);
begin
  if( not( Assigned( udp )))or( speUdpDestPort.Text = '' )then
    exit;

  udp.DestinationPort := speUdpDestPort.Text;
end;

procedure TfrmMain.speUdpListeningPortChanged(Sender: TObject; NewValue: Integer);
begin
  if( not( Assigned( udp )))or( speUdpListeningPort.Text = '' )then
    exit;

  udp.ListeningPort := speUdpListeningPort.Text;
end;


procedure TfrmMain.speTcpDestPortChanged(Sender: TObject; NewValue: Integer);
begin
  if( not( Assigned( clntTcp )))or( speTcpDestPort.Text = '' )then
    exit;

  clntTCP.Port := IntToStr( speTcpDestPort.Value );
end;

procedure TfrmMain.speTcpListeningPortChanged(Sender: TObject; NewValue: Integer);
begin
  if( not( Assigned( svrTcp )))or( speTcpListeningPort.Text = '' )then
    exit;

  svrTCP.Port := IntToStr( speTcpListeningPort.Value );
end;

procedure TfrmMain.speIpcListeningPortChanged(Sender: TObject; NewValue: Integer);
begin
  if( not( Assigned( svrIpc )))or( speIpcListeningPort.Text = '' )then
    exit;

  svrIpc.Port := IntToStr( speIpcListeningPort.Value );
end;

procedure TfrmMain.speIpcDestPortChanged(Sender: TObject; NewValue: Integer);
begin
  if( not( Assigned( clntIpc )))or( speIpcDestPort.Text = '' )then
    exit;

  clntIpc.Port := IntToStr( speIpcDestPort.Value );
end;

procedure TfrmMain.FormDestroy(Sender: TObject);
begin
  if Assigned( udp )then
    udp.Free;

  if Assigned( clntTCP )then
    clntTCP.Free;

  if Assigned( svrTcp )then
    svrTcp.Free;

  if Assigned( svrIpc )then
    svrIpc.Free;

  if Assigned( clntIpc )then
    clntIpc.Free;
end;



procedure TfrmMain.FormCreate(Sender: TObject);
begin
  SetPorts;
end;

procedure TfrmMain.SetPorts;
begin
  speUdpListeningPort.Value := 1500;
  speUdpDestPort.Value := 1501;

  speTcpListeningPort.Value := 1501;
  speTcpDestPort.Value := 1501;

  speIpcListeningPort.Value := 1502;
  speIpcDestPort.Value := 1502;
end;

end.
